/*
 * generated by Xtext
 */
package org.eclipse.gemoc.execution.moccml.runstar.xtext.serializer;

import com.google.inject.Inject;
import fr.inria.aoste.timesquare.ccslkernel.model.TimeModel.ImportStatement;
import fr.inria.aoste.timesquare.ccslkernel.model.TimeModel.TimeModelPackage;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.ChartVar;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Comment;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.ConstTextVar;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.DecoratedTextVar;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Hover;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Image;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.ImageVar;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.ImportJavaStatement;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Label;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Mark;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Paint;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RColor;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RStrategy;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RTDVar;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RUpdateStrategy;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RunstarPackage;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.RuntimeStateRepresentation;
import org.eclipse.gemoc.execution.moccml.runstar.model.Runstar.Stack;
import org.eclipse.gemoc.execution.moccml.runstar.xtext.services.RunstarGrammarAccess;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public abstract class AbstractRunstarSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private RunstarGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == RunstarPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case RunstarPackage.CHART_VAR:
				sequence_ChartVar(context, (ChartVar) semanticObject); 
				return; 
			case RunstarPackage.COMMENT:
				sequence_Comment(context, (Comment) semanticObject); 
				return; 
			case RunstarPackage.CONST_TEXT_VAR:
				sequence_ConstTextVar(context, (ConstTextVar) semanticObject); 
				return; 
			case RunstarPackage.DECORATED_TEXT_VAR:
				sequence_DecoratedTextVar(context, (DecoratedTextVar) semanticObject); 
				return; 
			case RunstarPackage.HOVER:
				sequence_Hover(context, (Hover) semanticObject); 
				return; 
			case RunstarPackage.IMAGE:
				sequence_Image(context, (Image) semanticObject); 
				return; 
			case RunstarPackage.IMAGE_VAR:
				sequence_ImageVar(context, (ImageVar) semanticObject); 
				return; 
			case RunstarPackage.IMPORT_JAVA_STATEMENT:
				sequence_ImportJavaStatement(context, (ImportJavaStatement) semanticObject); 
				return; 
			case RunstarPackage.LABEL:
				sequence_Label(context, (Label) semanticObject); 
				return; 
			case RunstarPackage.MARK:
				sequence_Mark(context, (Mark) semanticObject); 
				return; 
			case RunstarPackage.PAINT:
				sequence_Paint(context, (Paint) semanticObject); 
				return; 
			case RunstarPackage.RCOLOR:
				sequence_RColor(context, (RColor) semanticObject); 
				return; 
			case RunstarPackage.RSTRATEGY:
				sequence_RStrategy(context, (RStrategy) semanticObject); 
				return; 
			case RunstarPackage.RTD_VAR:
				sequence_RTDVar(context, (RTDVar) semanticObject); 
				return; 
			case RunstarPackage.RUPDATE_STRATEGY:
				sequence_RUpdateStrategy(context, (RUpdateStrategy) semanticObject); 
				return; 
			case RunstarPackage.RUNTIME_STATE_REPRESENTATION:
				sequence_RuntimeStateRepresentation(context, (RuntimeStateRepresentation) semanticObject); 
				return; 
			case RunstarPackage.STACK:
				sequence_Stack(context, (Stack) semanticObject); 
				return; 
			}
		else if (epackage == TimeModelPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case TimeModelPackage.IMPORT_STATEMENT:
				sequence_ImportStatement(context, (ImportStatement) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Variable returns ChartVar
	 *     ChartVar returns ChartVar
	 *
	 * Constraint:
	 *     (
	 *         (
	 *             xrtd=[RTDVar|ID] 
	 *             yrtds+=[RTDVar|ID] 
	 *             yrtds+=[RTDVar|ID]* 
	 *             path=STRING 
	 *             (title=STRING | xlabel=STRING | ylabel=STRING | nbValuesDisplayed=INT | lineStyle=LineStyle)* 
	 *             name=ID
	 *         ) | 
	 *         name=ID
	 *     )
	 */
	protected void sequence_ChartVar(ISerializationContext context, ChartVar semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Comment
	 *     Comment returns Comment
	 *
	 * Constraint:
	 *     text=[TextVar|ID]
	 */
	protected void sequence_Comment(ISerializationContext context, Comment semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getCommentAccess().getTextTextVarIDTerminalRuleCall_2_0_1(), semanticObject.eGet(RunstarPackage.Literals.REPRESENTATION__TEXT, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Variable returns ConstTextVar
	 *     TextVar returns ConstTextVar
	 *     ConstTextVar returns ConstTextVar
	 *
	 * Constraint:
	 *     (value=STRING strategy=RStrategy name=ID)
	 */
	protected void sequence_ConstTextVar(ISerializationContext context, ConstTextVar semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.CONST_TEXT_VAR__VALUE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.CONST_TEXT_VAR__VALUE));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.VARIABLE__STRATEGY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.VARIABLE__STRATEGY));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.VARIABLE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.VARIABLE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getConstTextVarAccess().getValueSTRINGTerminalRuleCall_2_0(), semanticObject.getValue());
		feeder.accept(grammarAccess.getConstTextVarAccess().getStrategyRStrategyParserRuleCall_3_0(), semanticObject.getStrategy());
		feeder.accept(grammarAccess.getConstTextVarAccess().getNameIDTerminalRuleCall_6_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Variable returns DecoratedTextVar
	 *     TextVar returns DecoratedTextVar
	 *     DecoratedTextVar returns DecoratedTextVar
	 *
	 * Constraint:
	 *     (
	 *         decorated=[TextVar|ID] 
	 *         (
	 *             prefix=STRING | 
	 *             suffix=STRING | 
	 *             font=STRING | 
	 *             fontSize=INT | 
	 *             fontStyle=FontStyle | 
	 *             color=RColor | 
	 *             errorText=STRING | 
	 *             errorColor=RColor
	 *         )* 
	 *         name=ID
	 *     )
	 */
	protected void sequence_DecoratedTextVar(ISerializationContext context, DecoratedTextVar semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Hover
	 *     Hover returns Hover
	 *
	 * Constraint:
	 *     ((text=[TextVar|ID] | image=[ImageVar|ID] | (text=[TextVar|ID] image=[ImageVar|ID])) fromStart=RBoolean?)
	 */
	protected void sequence_Hover(ISerializationContext context, Hover semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Variable returns ImageVar
	 *     ImageVar returns ImageVar
	 *
	 * Constraint:
	 *     (path=STRING strategy=RStrategy name=ID)
	 */
	protected void sequence_ImageVar(ISerializationContext context, ImageVar semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.IMAGE_VAR__PATH) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.IMAGE_VAR__PATH));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.VARIABLE__STRATEGY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.VARIABLE__STRATEGY));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.VARIABLE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.VARIABLE__NAME));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImageVarAccess().getPathSTRINGTerminalRuleCall_2_0(), semanticObject.getPath());
		feeder.accept(grammarAccess.getImageVarAccess().getStrategyRStrategyParserRuleCall_3_0(), semanticObject.getStrategy());
		feeder.accept(grammarAccess.getImageVarAccess().getNameIDTerminalRuleCall_6_0(), semanticObject.getName());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Image
	 *     Image returns Image
	 *
	 * Constraint:
	 *     (image=[ImageVar|ID] (initialSize=INT | depth=INT | text=[TextVar|ID])*)
	 */
	protected void sequence_Image(ISerializationContext context, Image semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ImportJavaStatement returns ImportJavaStatement
	 *
	 * Constraint:
	 *     (importedNamespace=QualifiedName | importedNamespace=QualifiedNameWithWildCard)
	 */
	protected void sequence_ImportJavaStatement(ISerializationContext context, ImportJavaStatement semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ImportStatement returns ImportStatement
	 *
	 * Constraint:
	 *     (importURI=EString (alias=';' | alias=EString))
	 */
	protected void sequence_ImportStatement(ISerializationContext context, ImportStatement semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Label
	 *     Label returns Label
	 *
	 * Constraint:
	 *     text=[TextVar|ID]
	 */
	protected void sequence_Label(ISerializationContext context, Label semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getLabelAccess().getTextTextVarIDTerminalRuleCall_2_0_1(), semanticObject.eGet(RunstarPackage.Literals.REPRESENTATION__TEXT, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Mark
	 *     Mark returns Mark
	 *
	 * Constraint:
	 *     (text=[TextVar|ID] markerType=MarkerType)
	 */
	protected void sequence_Mark(ISerializationContext context, Mark semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.REPRESENTATION__TEXT));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.MARK__MARKER_TYPE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.MARK__MARKER_TYPE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getMarkAccess().getTextTextVarIDTerminalRuleCall_2_0_1(), semanticObject.eGet(RunstarPackage.Literals.REPRESENTATION__TEXT, false));
		feeder.accept(grammarAccess.getMarkAccess().getMarkerTypeMarkerTypeEnumRuleCall_3_3_0(), semanticObject.getMarkerType());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Paint
	 *     Paint returns Paint
	 *
	 * Constraint:
	 *     (color=RColor? (type=PaintType | persistent=RBoolean)* onConcept=[EObject|QualifiedName]? ownedUpdateStrategy=RUpdateStrategy)
	 */
	protected void sequence_Paint(ISerializationContext context, Paint semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     RColor returns RColor
	 *
	 * Constraint:
	 *     (red=INT green=INT blue=INT)
	 */
	protected void sequence_RColor(ISerializationContext context, RColor semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.RCOLOR__RED) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.RCOLOR__RED));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.RCOLOR__GREEN) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.RCOLOR__GREEN));
			if (transientValues.isValueTransient(semanticObject, RunstarPackage.Literals.RCOLOR__BLUE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, RunstarPackage.Literals.RCOLOR__BLUE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getRColorAccess().getRedINTTerminalRuleCall_1_0(), semanticObject.getRed());
		feeder.accept(grammarAccess.getRColorAccess().getGreenINTTerminalRuleCall_3_0(), semanticObject.getGreen());
		feeder.accept(grammarAccess.getRColorAccess().getBlueINTTerminalRuleCall_5_0(), semanticObject.getBlue());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     RStrategy returns RStrategy
	 *
	 * Constraint:
	 *     (onConcept=[EObject|QualifiedName] ownedUpdateStrategy=RUpdateStrategy?)
	 */
	protected void sequence_RStrategy(ISerializationContext context, RStrategy semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Variable returns RTDVar
	 *     TextVar returns RTDVar
	 *     RTDVar returns RTDVar
	 *
	 * Constraint:
	 *     (attributes+=EString attributes+=EString* strategy=RStrategy name=ID)
	 */
	protected void sequence_RTDVar(ISerializationContext context, RTDVar semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     RUpdateStrategy returns RUpdateStrategy
	 *
	 * Constraint:
	 *     (stepExecution=StepExecution | (stepExecution=StepExecution events+=[DefPropertyCS|ID]) | (events+=[DefPropertyCS|ID] events+=[DefPropertyCS|ID]))
	 */
	protected void sequence_RUpdateStrategy(ISerializationContext context, RUpdateStrategy semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     RuntimeStateRepresentation returns RuntimeStateRepresentation
	 *
	 * Constraint:
	 *     (
	 *         (name=EString | name=EString) 
	 *         ((modelImports+=ImportStatement | classImports+=ImportJavaStatement) (modelImports+=ImportStatement | classImports+=ImportJavaStatement)*)? 
	 *         variables+=Variable? 
	 *         (representations+=Representation? variables+=Variable?)*
	 *     )
	 */
	protected void sequence_RuntimeStateRepresentation(ISerializationContext context, RuntimeStateRepresentation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Representation returns Stack
	 *     Stack returns Stack
	 *
	 * Constraint:
	 *     (
	 *         text=[TextVar|ID] 
	 *         (
	 *             maxLength=INT | 
	 *             isVertical=RBoolean | 
	 *             shape=StackShape | 
	 *             strategy=StackStrategy | 
	 *             title=STRING | 
	 *             depth=INT
	 *         )*
	 *     )
	 */
	protected void sequence_Stack(ISerializationContext context, Stack semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
